Index: /trunk/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApi/FactTaskController.cs
===================================================================
--- /trunk/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApi/FactTaskController.cs	(revision 12878)
+++ /trunk/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApi/FactTaskController.cs	(revision 12878)
@@ -0,0 +1,116 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using System.Web.Http;
+using HeuristicLab.Services.Hive;
+using HeuristicLab.Services.Hive.DataAccess;
+using HeuristicLab.Services.Hive.DataAccess.Interfaces;
+using DT = HeuristicLab.Services.WebApp.Maintenance.WebApi.DataTransfer;
+
+namespace HeuristicLab.Services.WebApp.Maintenance.WebApi {
+  public class FactTaskController : ApiController {
+    private IPersistenceManager PersistenceManager {
+      get { return ServiceLocator.Instance.PersistenceManager; }
+    }
+
+    public DT.JobPage GetJobs(DateTime start, DateTime end, int page, int size) {
+      var pm = PersistenceManager;
+      var dimJobDao = pm.DimJobDao;
+      var factTaskDao = pm.FactTaskDao;
+      return pm.UseTransaction(() => {
+        var query = dimJobDao.GetAll().Where(x => x.DateCreated >= start && x.DateCreated <= end);
+        return new DT.JobPage {
+          TotalJobs = query.Count(),
+          Jobs = query.OrderBy(x => x.DateCreated)
+            .Skip((page - 1) * size)
+            .Take(size)
+            .Select(x => new DT.Job {
+              Id = x.JobId,
+              Name = x.JobName,
+              Username = x.UserName,
+              DateCreated = x.DateCreated,
+              Tasks = x.TotalTasks,
+              Aggregated = !(factTaskDao.GetAll().Count(y => y.JobId == x.JobId) > 1)
+            })
+            .ToList()
+        };
+      });
+    }
+
+    [HttpPost]
+    public void AggregateJob(Guid id) {
+      var pm = PersistenceManager;
+      AggregateJob(pm, id);
+    }
+
+    [HttpPost]
+    public void AggregateAllJobs(DateTime start, DateTime end) {
+      var pm = PersistenceManager;
+      var dimJobDao = pm.DimJobDao;
+      var jobIds = pm.UseTransaction(() => dimJobDao.GetAll()
+        .Where(x => x.DateCreated >= start && x.DateCreated <= end)
+        .Select(x => x.JobId)
+        .ToList()
+      );
+      foreach (var id in jobIds) {
+        AggregateJob(pm, id);
+      }
+    }
+
+    private void AggregateJob(IPersistenceManager pm, Guid id) {
+      var jobDao = pm.JobDao;
+      var factTaskDao = pm.FactTaskDao;
+      pm.UseTransaction(() => {
+        if (jobDao.Exists(id)) return;
+        var jobTimeData = factTaskDao.GetByJobId(id).GroupBy(x => x.JobId).Select(x => new {
+          CalculatingTime = x.Sum(y => y.CalculatingTime),
+          WaitingTime = x.Sum(y => y.WaitingTime),
+          TransferTime = x.Sum(y => y.TransferTime),
+          InitialWaitingTime = x.Sum(y => y.InitialWaitingTime),
+          StartTime = x.Min(y => y.StartTime),
+          EndTime = x.Max(y => y.EndTime)
+        }).SingleOrDefault();
+        if (jobTimeData != null) {
+          factTaskDao.DeleteByJobId(id);
+          factTaskDao.Save(new FactTask {
+            TaskId = Guid.NewGuid(),
+            JobId = id,
+            CalculatingTime = jobTimeData.CalculatingTime,
+            WaitingTime = jobTimeData.WaitingTime,
+            TransferTime = jobTimeData.TransferTime,
+            InitialWaitingTime = jobTimeData.InitialWaitingTime,
+            StartTime = jobTimeData.StartTime,
+            EndTime = jobTimeData.EndTime,
+            NumCalculationRuns = 0,
+            NumRetries = 0,
+            CoresRequired = 0,
+            MemoryRequired = 0,
+            Priority = 0,
+            TaskState = TaskState.Finished
+          });
+        }
+        pm.SubmitChanges();
+      });
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApi/PluginController.cs
===================================================================
--- /trunk/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApi/PluginController.cs	(revision 12878)
+++ /trunk/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApi/PluginController.cs	(revision 12878)
@@ -0,0 +1,82 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using System.Web.Http;
+using HeuristicLab.Services.Hive;
+using HeuristicLab.Services.Hive.DataAccess.Interfaces;
+using DT = HeuristicLab.Services.WebApp.Maintenance.WebApi.DataTransfer;
+
+namespace HeuristicLab.Services.WebApp.Maintenance.WebApi {
+  public class PluginController : ApiController {
+    private IPersistenceManager PersistenceManager {
+      get { return ServiceLocator.Instance.PersistenceManager; }
+    }
+
+    public DT.PluginPage GetUnusedPlugins(int page, int size) {
+      var pm = PersistenceManager;
+      var pluginDao = pm.PluginDao;
+      var requiredPluginDao = pm.RequiredPluginDao;
+      var taskDao = pm.TaskDao;
+      return pm.UseTransaction(() => {
+        var taskIds = taskDao.GetAll().Select(x => x.TaskId);
+        var usedPluginIds = requiredPluginDao.GetAll()
+          .Where(x => taskIds.Contains(x.TaskId))
+          .Select(x => x.PluginId)
+          .Distinct();
+        var query = pluginDao.GetAll().Where(x => !usedPluginIds.Any(y => y == x.PluginId));
+        return new DT.PluginPage {
+          TotalPlugins = query.Count(),
+          Plugins = query.OrderBy(x => x.DateCreated).ThenBy(x => x.Name)
+            .Skip((page - 1) * size)
+            .Take(size).Select(x => new DT.Plugin {
+              Id = x.PluginId,
+              Name = x.Name,
+              Version = x.Version,
+              DateCreated = x.DateCreated
+            })
+            .ToList()
+        };
+      });
+    }
+
+    [HttpPost]
+    public void DeletePlugin(Guid id) {
+      var pm = PersistenceManager;
+      var pluginDao = pm.PluginDao;
+      pm.UseTransaction(() => {
+        pluginDao.Delete(id);
+        pm.SubmitChanges();
+      });
+    }
+
+    [HttpPost]
+    public void DeleteUnusedPlugins() {
+      var pm = PersistenceManager;
+      var pluginDao = pm.PluginDao;
+      pm.UseTransaction(() => {
+        pluginDao.DeleteUnusedPlugins();
+        pm.SubmitChanges();
+      });
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApi/SpaceUsageController.cs
===================================================================
--- /trunk/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApi/SpaceUsageController.cs	(revision 12878)
+++ /trunk/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApi/SpaceUsageController.cs	(revision 12878)
@@ -0,0 +1,93 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Linq;
+using System.Web.Http;
+using HeuristicLab.Services.Hive;
+using HeuristicLab.Services.Hive.DataAccess.Interfaces;
+using HeuristicLab.Services.WebApp.Maintenance.WebApi.DataTransfer;
+using DA = HeuristicLab.Services.Hive.DataAccess.Data;
+
+namespace HeuristicLab.Services.WebApp.Maintenance.WebApi {
+  public class SpaceUsageController : ApiController {
+    private IPersistenceManager PersistenceManager {
+      get { return ServiceLocator.Instance.PersistenceManager; }
+    }
+
+    public IEnumerable<TableInformation> GetHiveTableInformation() {
+      var tables = new List<string> {
+        "AssignedResources",
+        "Downtime",
+        "Job",
+        "JobPermission",
+        "Lifecycle",
+        "Plugin",
+        "PluginData",
+        "RequiredPlugins",
+        "Resource",
+        "ResourcePermission",
+        "StateLog",
+        "Task",
+        "TaskData",
+        "UserPriority"
+      };
+      var pm = PersistenceManager;
+      return pm.UseTransaction(() => (
+          from table in tables
+          select pm.GetTableInformation(table) into tableInformation
+          where tableInformation != null
+          select Convert(tableInformation)
+          ).ToList()
+        );
+    }
+
+    public IEnumerable<TableInformation> GetStatisticsTableInformation() {
+      var tables = new List<string> {
+        "statistics.DimClient",
+        "statistics.DimJob",
+        "statistics.DimTime",
+        "statistics.DimUser",
+        "statistics.FactClientInfo",
+        "statistics.FactTask"
+      };
+      var pm = PersistenceManager;
+      return pm.UseTransaction(() => (
+          from table in tables
+          select pm.GetTableInformation(table) into tableInformation
+          where tableInformation != null
+          select Convert(tableInformation)
+          ).ToList()
+        );
+    }
+
+    private TableInformation Convert(DA.TableInformation tableInformation) {
+      return new TableInformation {
+        Name = tableInformation.Name,
+        Rows = tableInformation.Rows,
+        Reserved = tableInformation.Reserved,
+        Data = tableInformation.Data,
+        IndexSize = tableInformation.IndexSize,
+        Unused = tableInformation.Unused
+      };
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApp/factclientinfo/factclientinfo.cshtml
===================================================================
--- /trunk/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApp/factclientinfo/factclientinfo.cshtml	(revision 12878)
+++ /trunk/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApp/factclientinfo/factclientinfo.cshtml	(revision 12878)
@@ -0,0 +1,77 @@
+﻿@using HeuristicLab.Services.Hive
+<header class="view-header">
+    <ul class="nav nav-list nav-list-topbar pull-left">
+        <li>
+            <a ng-href="#/maintenance/spaceusage">Space Usage</a>
+        </li>
+        <li>
+            <a ng-href="#/maintenance/plugin">Plugin</a>
+        </li>
+        <li>
+            <a ng-href="#/maintenance/facttask">FactTask</a>
+        </li>
+        <li class="active">
+            <a ng-href="#/maintenance/factclientinfo">FactClientInfo</a>
+        </li>
+    </ul>
+</header>
+
+<div class="default-view-header">
+    <form class="form-inline">
+        <div class="form-group" style="margin-left: 5px; margin-right: 5px;">
+            <label for="fromDate">From:&nbsp;</label>
+            <div class="input-group">
+                <input id="fromDate" type="text" class="form-control" datepicker-popup="dd.MM.yyyy" ng-model="fromDate" is-open="fromIsOpen" datepicker-options="dateOptions" ng-required="true" close-text="Close" />
+                <span class="input-group-btn">
+                    <button type="button" class="btn btn-default" ng-click="openFromDateSelection($event)"><i class="glyphicon glyphicon-calendar"></i></button>
+                </span>
+            </div>
+        </div>
+        <div class="form-group" style="margin-left: 5px; margin-right: 5px;">
+            <label for="fromDate">To:&nbsp;</label>
+            <div class="input-group">
+                <input id="fromDate" type="text" class="form-control" datepicker-popup="dd.MM.yyyy" ng-model="toDate" is-open="toIsOpen" datepicker-options="dateOptions" ng-required="true" close-text="Close" />
+                <span class="input-group-btn">
+                    <button type="button" class="btn btn-default" ng-click="openToDateSelection($event)"><i class="glyphicon glyphicon-calendar"></i></button>
+                </span>
+            </div>
+        </div>
+        <div class="form-group" style="margin-left: 5px; margin-right: 5px;">
+            <button type="button" class="btn btn-default" ng-click="getFactClientInfo()">
+                Apply
+            </button>
+        </div>
+    </form>
+</div>
+
+<div class="default-view-container">
+    <div class="row">
+        <div class="col-lg-12">
+            <div class="panel panel-default">
+                <div class="panel-heading">
+                    <h3 class="panel-title">FactClientInfo</h3>
+                </div>
+                <div class="panel-body">
+                    <form class="form-inline">
+                        <div class="form-group" style="margin-left: 5px; margin-right: 5px;">
+                            <label>Rows:&nbsp;{{factClientInfo.Rows}}</label>
+                        </div>
+                        <div class="form-group" style="margin-left: 5px; margin-right: 5px;">
+                            <label>Clients:&nbsp;{{factClientInfo.Clients}}</label>
+                        </div>
+                        <div class="form-group" style="margin-left: 5px; margin-right: 5px;">
+                            <label for="entries">Entries:&nbsp;</label>
+                            <input id="entries" type="number" class="form-control"
+                                   ng-model="entries" min="2"/>
+                        </div>
+                        <div class="form-group" style="margin-left: 5px; margin-right: 5px;">
+                            <button type="button" class="btn btn-default" ng-click="aggregate()">
+                                Aggregate
+                            </button>
+                        </div>
+                    </form>
+                </div>
+            </div>
+        </div>
+    </div>
+</div>
Index: /trunk/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApp/factclientinfo/factclientinfoCtrl.js
===================================================================
--- /trunk/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApp/factclientinfo/factclientinfoCtrl.js	(revision 12878)
+++ /trunk/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApp/factclientinfo/factclientinfoCtrl.js	(revision 12878)
@@ -0,0 +1,58 @@
+﻿(function () {
+    var module = appMaintenancePlugin.getAngularModule();
+    module.controller('app.maintenance.factclientinfoCtrl',
+        ['$scope', '$interval', 'app.maintenance.factclientinfoService', function ($scope, $interval, factclientinfoService) {
+            $scope.interval = defaultPageUpdateInterval;
+            $scope.entries = 2;
+
+            $scope.fromDate = new Date();
+            $scope.toDate = new Date();
+
+            $scope.fromIsOpen = false;
+            $scope.toIsOpen = false;
+
+            $scope.openFromDateSelection = function ($event) {
+                $event.preventDefault();
+                $event.stopPropagation();
+                $scope.toIsOpen = false;
+                $scope.fromIsOpen = true;
+            };
+
+            $scope.openToDateSelection = function ($event) {
+                $event.preventDefault();
+                $event.stopPropagation();
+                $scope.fromIsOpen = false;
+                $scope.toIsOpen = true;
+            };
+
+            $scope.dateOptions = {
+                formatYear: 'yy',
+                startingDay: 1
+            };
+
+            $scope.getFactClientInfo = function () {
+                factclientinfoService.getFactClientInfo({
+                    start: ConvertFromDate($scope.fromDate),
+                    end: ConvertToDate($scope.toDate)
+                },
+                function (factClientInfo) {
+                    $scope.factClientInfo = factClientInfo;
+                    $scope.aggregateStartDate = ConvertFromDate($scope.fromDate);
+                    $scope.aggregateEndDate = ConvertToDate($scope.toDate);
+                });
+            };
+
+            $scope.aggregate = function () {
+                factclientinfoService.aggregate({
+                    start: $scope.aggregateStartDate,
+                    end: $scope.aggregateEndDate,
+                    entries: $scope.entries
+                }, function () {
+                    $scope.getFactClientInfo();
+                });
+            };
+
+            $scope.getFactClientInfo(); // init page
+        }]
+    );
+})();
Index: /trunk/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApp/facttask/facttask.cshtml
===================================================================
--- /trunk/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApp/facttask/facttask.cshtml	(revision 12878)
+++ /trunk/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApp/facttask/facttask.cshtml	(revision 12878)
@@ -0,0 +1,90 @@
+﻿@using HeuristicLab.Services.Hive
+<header class="view-header">
+    <ul class="nav nav-list nav-list-topbar pull-left">
+        <li>
+            <a ng-href="#/maintenance/spaceusage">Space Usage</a>
+        </li>
+        <li>
+            <a ng-href="#/maintenance/plugin">Plugin</a>
+        </li>
+        <li class="active">
+            <a ng-href="#/maintenance/facttask">FactTask</a>
+        </li>
+        <li>
+            <a ng-href="#/maintenance/factclientinfo">FactClientInfo</a>
+        </li>
+    </ul>
+</header>
+
+<div class="default-view-header">
+    <form class="form-inline">
+        <div class="form-group" style="margin-left: 5px; margin-right: 5px;">
+            <label for="fromDate">From:&nbsp;</label>
+            <div class="input-group">
+                <input id="fromDate" type="text" class="form-control" datepicker-popup="dd.MM.yyyy" ng-model="fromDate" is-open="fromIsOpen" datepicker-options="dateOptions" ng-required="true" close-text="Close" />
+                <span class="input-group-btn">
+                    <button type="button" class="btn btn-default" ng-click="openFromDateSelection($event)"><i class="glyphicon glyphicon-calendar"></i></button>
+                </span>
+            </div>
+        </div>
+        <div class="form-group" style="margin-left: 5px; margin-right: 5px;">
+            <label for="fromDate">To:&nbsp;</label>
+            <div class="input-group">
+                <input id="fromDate" type="text" class="form-control" datepicker-popup="dd.MM.yyyy" ng-model="toDate" is-open="toIsOpen" datepicker-options="dateOptions" ng-required="true" close-text="Close" />
+                <span class="input-group-btn">
+                    <button type="button" class="btn btn-default" ng-click="openToDateSelection($event)"><i class="glyphicon glyphicon-calendar"></i></button>
+                </span>
+            </div>
+        </div>
+        <div class="form-group" style="margin-left: 5px; margin-right: 5px;">
+            <button type="button" class="btn btn-default" ng-click="getJobs()">
+                Apply
+            </button>
+        </div>
+    </form>
+</div>
+
+<div class="default-view-container">
+    <div class="row">
+        <div class="col-lg-12">
+            <div class="panel panel-default">
+                <div class="panel-heading">
+                    <h3 class="panel-title">Jobs</h3>
+                </div>
+                <div class="panel-body">
+                    <table class="table table-hover table-condensed" ts-wrapper>
+                        <thead>
+                        <tr>
+                            <th>#</th>
+                            <th ts-criteria="Name">Job Name</th>
+                            <th ts-criteria="Username">Username</th>
+                            <th ts-criteria="DateCreated">Date Created</th>
+                            <th ts-criteria="Tasks">Tasks</th>
+                            <th class="text-center">
+                                <a ng-show="jobPage.Jobs.length" class="cursor-pointer" ng-href="" ng-click="aggregateAllJobs()">Aggregate All</a>
+                            </th>
+                        </tr>
+                        </thead>
+                        <tbody>
+                            <tr ng-repeat="job in jobPage.Jobs" ts-repeat>
+                                <td>{{($index + 1)+((curJobsPage-1)*(jobsPageSize))}}</td>
+                                <td>{{job.Name}}</td>
+                                <td>{{job.Username}}</td>
+                                <td>{{job.DateCreated | toDate}}</td>
+                                <td>{{job.Tasks}}</td>
+                                <td class="text-center">
+                                    <a ng-hide="job.Aggregated" class="cursor-pointer" ng-href="" ng-click="aggregateJob(job.Id)">Aggregate</a>
+                                </td>
+                            </tr>
+                        </tbody>
+                    </table>
+                    <div class="row text-center" ng-show="jobPage.TotalJobs > jobPage.Jobs.length">
+                        <pagination max-size="10" total-items="jobPage.TotalJobs" ng-model="curJobsPage" ng-change="changeJobsPage()" items-per-page="jobsPageSize"
+                                    boundary-links="true" rotate="false" num-pages="numPages"></pagination>
+                    </div>
+                </div>
+            </div>
+        </div>
+    </div>
+
+</div>
Index: /trunk/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApp/facttask/facttaskCtrl.js
===================================================================
--- /trunk/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApp/facttask/facttaskCtrl.js	(revision 12878)
+++ /trunk/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApp/facttask/facttaskCtrl.js	(revision 12878)
@@ -0,0 +1,69 @@
+﻿(function () {
+    var module = appMaintenancePlugin.getAngularModule();
+    module.controller('app.maintenance.facttaskCtrl',
+        ['$scope', '$interval', 'app.maintenance.facttaskService', function ($scope, $interval, facttaskService) {
+            $scope.interval = defaultPageUpdateInterval;
+            $scope.curJobsPage = 1;
+            $scope.jobsPageSize = 20;
+
+            $scope.fromDate = new Date();
+            $scope.toDate = new Date();
+
+            $scope.fromIsOpen = false;
+            $scope.toIsOpen = false;
+
+            $scope.openFromDateSelection = function ($event) {
+                $event.preventDefault();
+                $event.stopPropagation();
+                $scope.toIsOpen = false;
+                $scope.fromIsOpen = true;
+            };
+
+            $scope.openToDateSelection = function ($event) {
+                $event.preventDefault();
+                $event.stopPropagation();
+                $scope.fromIsOpen = false;
+                $scope.toIsOpen = true;
+            };
+
+            $scope.dateOptions = {
+                formatYear: 'yy',
+                startingDay: 1
+            };
+
+            $scope.getJobs = function () {
+                facttaskService.getJobs({
+                    start: ConvertFromDate($scope.fromDate),
+                    end: ConvertToDate($scope.toDate),
+                    page: $scope.curJobsPage,
+                    size: $scope.jobsPageSize
+                },
+                function (jobPage) {
+                    $scope.jobPage = jobPage;
+                });
+            };
+
+            $scope.aggregateJob = function (id) {
+                facttaskService.aggregateJob({ id: id }, function () {
+                    $scope.getJobs();
+                });
+            };
+
+            $scope.aggregateAllJobs = function () {
+                facttaskService.aggregateAllJobs({
+                    start: ConvertFromDate($scope.fromDate),
+                    end: ConvertToDate($scope.toDate)
+                },
+                function () {
+                    $scope.getJobs();
+                });
+            };
+
+            $scope.changeJobsPage = function () {
+                $scope.getJobs();
+            };
+
+            $scope.getJobs(); // init page
+        }]
+    );
+})();
Index: /trunk/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApp/plugin/plugin.cshtml
===================================================================
--- /trunk/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApp/plugin/plugin.cshtml	(revision 12878)
+++ /trunk/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApp/plugin/plugin.cshtml	(revision 12878)
@@ -0,0 +1,58 @@
+﻿@using HeuristicLab.Services.Hive
+<header class="view-header">
+    <ul class="nav nav-list nav-list-topbar pull-left">
+        <li>
+            <a ng-href="#/maintenance/spaceusage">Space Usage</a>
+        </li>
+        <li class="active">
+            <a ng-href="#/maintenance/plugin">Plugin</a>
+        </li>
+        <li>
+            <a ng-href="#/maintenance/facttask">FactTask</a>
+        </li>
+        <li>
+            <a ng-href="#/maintenance/factclientinfo">FactClientInfo</a>
+        </li>
+    </ul>
+</header>
+
+<div class="default-view-container">
+    <div class="row">
+        <div class="col-lg-12">
+            <div class="panel panel-default">
+                <div class="panel-heading">
+                    <h3 class="panel-title">Unused Plugins</h3>
+                </div>
+                <div class="panel-body">
+                    <table class="table table-hover table-condensed" ts-wrapper>
+                        <thead>
+                            <tr>
+                                <th>#</th>
+                                <th ts-criteria="Name">Plugin Name</th>
+                                <th ts-criteria="Version">Version</th>
+                                <th ts-criteria="DateCreated">Date Created</th>
+                                <th class="text-center">
+                                    <a ng-show="pluginPage.Plugins.length" class="cursor-pointer" ng-href="" ng-click="deleteUnusedPlugins()">Delete All</a>
+                                </th>
+                            </tr>
+                        </thead>
+                        <tbody>
+                            <tr ng-repeat="plugin in pluginPage.Plugins" ts-repeat>
+                                <td>{{($index + 1)+((curPluginsPage-1)*(pluginsPageSize))}}</td>
+                                <td>{{plugin.Name}}</td>
+                                <td>{{plugin.Version}}</td>
+                                <td>{{plugin.DateCreated | toDate}}</td>
+                                <td class="text-center"><a class="cursor-pointer" ng-href="" ng-click="deletePlugin(plugin.Id)">Delete</a></td>
+                            </tr>
+                        </tbody>
+                    </table>
+                    <div class="row text-center" ng-show="pluginPage.TotalPlugins > pluginPage.Plugins.length">
+                        <pagination max-size="10" total-items="pluginPage.TotalPlugins" ng-model="curPluginsPage" ng-change="changePluginsPage()" items-per-page="pluginsPageSize"
+                                    boundary-links="true" rotate="false" num-pages="numPages"></pagination>
+                    </div>
+                </div>
+            </div>
+        </div>
+    </div>
+
+</div>
Index: /trunk/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApp/plugin/pluginCtrl.js
===================================================================
--- /trunk/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApp/plugin/pluginCtrl.js	(revision 12878)
+++ /trunk/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApp/plugin/pluginCtrl.js	(revision 12878)
@@ -0,0 +1,39 @@
+﻿(function () {
+    var module = appMaintenancePlugin.getAngularModule();
+    module.controller('app.maintenance.pluginCtrl',
+        ['$scope', '$interval', 'app.maintenance.pluginService', function ($scope, $interval, pluginService) {
+            $scope.interval = defaultPageUpdateInterval;
+            $scope.curPluginsPage = 1;
+            $scope.pluginsPageSize = 20;
+
+            var getUnusedPlugins = function () {
+                pluginService.getUnusedPlugins({ page: $scope.curPluginsPage, size: $scope.pluginsPageSize }, function (pluginPage) {
+                    $scope.pluginPage = pluginPage;
+                });
+            };
+
+            $scope.deletePlugin = function(id) {
+                pluginService.deletePlugin({ id: id }, function() {
+                    getUnusedPlugins();
+                });
+            };
+
+            $scope.deleteUnusedPlugins = function() {
+                pluginService.deleteUnusedPlugins({}, function() {
+                    getUnusedPlugins();
+                });
+            };
+
+            $scope.changePluginsPage = function () {
+                getUnusedPlugins();
+            };
+
+            $scope.updateInterval = $interval(getUnusedPlugins, $scope.interval);
+            var cancelInterval = $scope.$on('$locationChangeSuccess', function () {
+                $interval.cancel($scope.updateInterval);
+                cancelInterval();
+            });
+            getUnusedPlugins(); // init page
+        }]
+    );
+})();
